<template>
  <div id="app-main-container">
    <el-container id="app-container">
      <!-- <el-header>
        <app-header />
      </el-header> -->

      <el-container>
        <app-icon-sidebar />
        <app-sidebar />

        <el-container>
          <el-tabs v-model="editableTabsValue" type="border-card" editable @edit="handleTabsEdit" id="content-window">
            <el-tab-pane
              v-for="(item, index) in editableTabs"
              :key="item.name"
              :label="item.title"
              :name="item.name"
            >
              <nuxt :tab="item"/>
            </el-tab-pane>
          </el-tabs>
          <!-- <el-header>
            <app-tabbar />
          </el-header>

          <el-main>
            <nuxt />
          </el-main> -->
        </el-container>
      </el-container>
    </el-container>

    <app-statusbar />
  </div>
</template>

<script>
  import appHeader from '@/components/header'
  import appIconSidebar from '@/components/icon-sidebar'
  import appSidebar from '@/components/sidebar'
  import appTabbar from '@/components/tabbar'
  import appStatusbar from '@/components/statusbar'

  export default {
    components: { 
      appHeader,
      appIconSidebar,
      appSidebar,
      appTabbar,
      appStatusbar
    },
    data() {
      return {
        editableTabsValue: '1',
        editableTabs: [{
          title: 'aaron@aarons-macbook-pro',
          name: '1',
          content: 'Tab 1 content'
        }, {
          title: 'root@test.termite.app',
          name: '2',
          content: 'Tab 2 content'
        }],
        tabIndex: 1
      }
    },
    methods: {
      handleTabsEdit(targetName, action) {
        if (action === 'add') {
          let newTabName = ++this.tabIndex + '';
          this.editableTabs.push({
            title: 'New Tab',
            name: newTabName,
            content: 'New Tab content'
          });
          this.editableTabsValue = newTabName;
        }
        if (action === 'remove') {
          let tabs = this.editableTabs;
          let activeName = this.editableTabsValue;
          if (activeName === targetName) {
            tabs.forEach((tab, index) => {
              if (tab.name === targetName) {
                let nextTab = tabs[index + 1] || tabs[index - 1];
                if (nextTab) {
                  activeName = nextTab.name;
                }
              }
            });
          }
          
          this.editableTabsValue = activeName;
          this.editableTabs = tabs.filter(tab => tab.name !== targetName);
        }
      }
    }
  }
</script>

<style lang="scss">
  html, body, #__nuxt, #__layout, #app-main-container {
    width: 100%;
    height: 100%;
  }
  body {
    margin: 0 !important;
    font-family: "Helvetica Neue",Helvetica,"PingFang SC","Hiragino Sans GB","Microsoft YaHei","微软雅黑",Arial,sans-serif;
  }

  #app-container {
    height: calc(100% - 20px);

    #content-window {
      width: 100%;

      
    }

    .el-tabs--border-card {
      background: #FFF;
      border-color: #DCDFE6;
      border-style: solid;
      border-width: 0px 0px 0px 1px !important;
      box-shadow: none !important;
    }

    .el-tabs--border-card > .el-tabs__content {
      padding: 0;
      height: 100%;
    }
    .el-tab-pane {
      height: 100%;
    }
  }

  .el-main {
    padding: 0 !important;
  }
</style>
